#include <MeMCore.h>
char newkey=0;
class car{
  private:
    MeIR ir;  
    MBotDCMotor motor=MBotDCMotor(0); 
    MeRGBLed rgbled_7=MeRGBLed(7,2); 
    MeBuzzer buzzer;
    bool flag_inc=false,flag_dec=false,flag_led=false,flag_buz=false;
    byte LedTimes=0;
  public:       
    void MotorMove(char x){
      static byte mBotSpeed=100;
      static byte mBotDirection=0;
      
      if(x=='i' && flag_inc==false){
        flag_inc=true;
        mBotSpeed=mBotSpeed+10;
        if(mBotSpeed>=255)mBotSpeed=255;
      }
      
      if(x=='d' && flag_dec==false){
        flag_dec=true;
        mBotSpeed=mBotSpeed-10;
        if(mBotSpeed<=80)mBotSpeed=80;
      }
      if(x=='f')mBotDirection=1;
      if(x=='b')mBotDirection=2;
      if(x=='l')mBotDirection=3;
      if(x=='r')mBotDirection=4;
      if(x=='i' || x=='d' || x=='f' || x=='b' || x=='l' || x=='r')motor.move(mBotDirection,mBotSpeed);
      if(x=='s')motor.move(1,0);
    }
    void Led(char x){
       if(x=='g' && flag_led==false){
            flag_led=true;
            LedTimes++;
            if((LedTimes%2)==0){
              LedTimes=0;
              rgbled_7.setColor(1,0,0,150);
              rgbled_7.setColor(2,0,0,150);
              rgbled_7.show();  
            }else{
              rgbled_7.setColor(1,0,0,0);
              rgbled_7.setColor(2,0,0,0);
              rgbled_7.show();
            }   
       }
    }
    void Buzz(char x){
      if(x=='a' && flag_buz==false){
        flag_buz=true;
        buzzer.tone(880,100);
      }
    }
    void IrBegin(){
      ir.begin(); 
    } 
    char IrKey(){
      char temp=0; //不設鈴,不確定值,就有可能有誤動作
      if(ir.keyPressed(64))temp='f'; //車子前進
      if(ir.keyPressed(25))temp='b'; //車子後退
      if(ir.keyPressed(7))temp='l'; //車子左轉
      if(ir.keyPressed(9))temp='r'; //車子右轉
      if(ir.keyPressed(21))temp='s'; //車子停止
      if(ir.keyPressed(69))temp='g'; //開關車燈---A
      if(ir.keyPressed(70))temp='a'; //喇叭---B
      if(ir.keyPressed(74))temp='i'; //車子加速--9
      if(ir.keyPressed(12))temp='d'; //車子減速--1
      if(temp==0){
        flag_inc=false;
        flag_dec=false;
        flag_led=false;
        flag_buz=false;
      }
      return temp;
    }    
}mBot;

void setup(){
    mBot.IrBegin();
    Serial.begin(115200);
}

void loop(){
  newkey=mBot.IrKey();
  if(newkey!=0){
      mBot.Led(newkey);
      mBot.MotorMove(newkey);
      mBot.Buzz(newkey);
  }
}

