#include <Arduino.h>
#include <MeMCore.h>
MeBuzzer buzzer;
char Music[]="cdeccdecefg0efg0gagfecgagfeccpc0cpc0"; //變數不能有中文,會有錯誤訊息:stray '\345' in program
char Tempo[]="222222222222222211112211112222222222";
void setup(){
  pinMode(A7,INPUT);
}

void loop(){
   if(analogRead(A7)==0){ //不能直接寫A7
      int i,freq,tpo;
      for(i=0;i<sizeof(Music)/sizeof(Music[0])-1;i++){
        //--音符--音樂彈到哪個音--
        if (Music[i]=='c'){freq=262;} //Do
        if (Music[i]=='d'){freq=294;} //Re
        if (Music[i]=='e'){freq=330;} //Mi
        if (Music[i]=='f'){freq=349;}
        if (Music[i]=='g'){freq=392;}
        if (Music[i]=='a'){freq=440;}
        if (Music[i]=='b'){freq=494;}
        if (Music[i]=='p'){freq=196;} //低8度so
        if (Music[i]=='0'){
          freq=0;//休息,蜂鳴器不叫就不會延遲
          delay(600);//當一拍
        }
        //--tempo--拍子--一個音符是半拍還是一拍還是兩拍---(2)
        if (Tempo[i]=='1'){tpo=300;} //半拍
        if (Tempo[i]=='2'){tpo=600;} //1拍
        if (Tempo[i]=='3'){tpo=90;}
        if (Tempo[i]=='4'){tpo=1200;}
        
        buzzer.tone(freq,tpo); //音頻,音的長短 
        //delay(50);
      }
      buzzer.noTone();  //off
     
   }
    
}

