#include <MeMCore.h>
MBotDCMotor motor(0);
MeIR ir;            // 宣告紅外線物件
int num=0;
int code_in[16],code_ans[]={1,2,3};
int ircode[]={22,12,24,94,8,28,90,66,82,74}; //遙控器0~9按鍵值
bool keyup=false;//可收值
bool error=false; //沒錯,代表密碼正確
int irValue;
void setup(){
  ir.begin();         // 啟動紅外線
  Serial.begin(115200);
}

void loop(){
    irValue=ir.getCode();
    if(keyup==false && irValue!=0 && irValue!=67){//0代表放開,67代表結算
      keyup=true; //只收一次
      for(int i=0;i<10;i++){//看哪個值相符
        if(irValue==ircode[i]){
          code_in[num]=i;
          Serial.println(i);
        }
      }    
      num++;
     }
     
    if(keyup==false && ir.keyPressed(67)){
      //收值與結算
      keyup=true; //只收一次
      error=false; //比對前,都先假設沒錯
      for(int i=0;i<sizeof(code_ans)/sizeof(code_ans[0]);i++){
        Serial.println(code_in[i]); //test
        Serial.println(code_ans[i]);
        Serial.println("---");
        if(code_in[i]!=code_ans[i]){
          error=true;
          Serial.println("F"); //有錯
        }  
        code_in[i]=' ';//clean
      }
      num=0;  //可重新輸入
      if(error==false)Serial.println("P");//密碼正確
     }
     
     //等放開
     if(keyup==true && ir.keyPressed(0)){//放開了
        keyup=false; //可再收值
        //Serial.println("0");
     }
}



